/* readfile.c -- Copyright 1992 Liam R. E. Quin.  All Rights Reserved.
 * This code is NOT in the public domain.
 * See the file COPYRIGHT for full details.
 */

/* $Id: readfile.c,v 1.6 92/07/05 12:50:06 lee Exp $
 * readfile - read files or lines into memory.
 */

#include <stdio.h>
#include <ctype.h>

#include "globals.h"
#include "emalloc.h"

extern int AsciiTrace;

#include <stdio.h>
#include <ctype.h>	/* isspace() etc */
#include <malloc.h>	/* This declares malloc(), realloc() etc... */

#include "globals.h"
#include "error.h"
#include "emalloc.h"

#include "readfile.h"

long
ReadFile(Severity, Name, What, Lines, Flags)
    int Severity;	/* to pass to Error() if necessary */
    char *Name;		/* the filename to read */
    char *What;
    char ***Lines;
    int Flags;
{
    FILE *f;
    long NLines;
    extern FILE *fEopen();

    f = fEopen(Severity, Name, What, "r");

    if (f == (FILE *) 0) {
	if (Lines) {
	    *Lines = (char **) 0;
	}
	return -1L;
    }

    NLines = fReadFile(Severity, f, Name, What, Lines, Flags);

    if (fclose(f) == EOF) {
	Error(E_WARN|E_SYS, "Couldn't close \"%s\" (%s)", Name, What);
	/* This is a little improbable -- and most likely an NFS problem,
	 * but the message could save a lot of frustration.  Perhaps I
	 * should have an fEclose()...
	 */
    }

    return NLines;
}
